//
// C++ Interface: CCatalogEdit
//
// Description: 
//
//
// Author: Harald Krippel <harald@the-develop.net>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//

#ifndef CCATALOGEDITDLG_H
#define CCATALOGEDITDLG_H

/**
  *@author Krippel Harald
  */

#include <QDialog>
#include <QString>
#include <QPixmap>

#include "ui_catalogdlg4.h"
#include "CQcakeDlg.hpp"
#include "listviews.hpp"


class CCatalogEditDlg: public CQcakeDlg
{
    Q_OBJECT
      
public:
    typedef struct Item{
        QString strName;
    };

    CCatalogEditDlg(QString, QWidget * parent = 0, QString tmppath = "",QDir::Filter filters=QDir::AllEntries, Qt::WFlags f = 0 );
    ~CCatalogEditDlg();
    QString getfile();
    QString getpath();
    QString getcatpath();
    void    fillcombo();
    void    fillicon(QDir::Filter filters);


public slots:
    virtual void slotGetData();
    virtual void slotEditData();
 
    virtual void slotGetCatPath();
    virtual void slotGetCombo();
    virtual void click(QModelIndex index);
    void doubleclick(QModelIndex index);

private slots:
 
protected: 
    Ui::Dialog ui;    

    QDir    tmpdir;
    QString tmppath;
    QString catpath;
    QString path;
    QString file;
    int state;

private:
    QWidget *myParent;
    QStandardItemModel *model;
    QDir::Filter catfilter;
};
#endif
